#ifndef UTILITIES_H
#define UTILITIES_H

#include <iostream>
#include <string>
#include <vector>
#include <sstream>

#include "strings_definitions.h"
#include <errhand.h>

#ifndef SEVN
#include <CL/cl_platform.h> //for cl_int2
#else 
#include <sevnonly_types.h>
#endif

#define errhand_macro(err) errhand(err, __FILE__, __LINE__)

using namespace std;

class utilities{

	public:
		utilities(){}
		float SplitArray(vector<float> &array, vector<string> &ind, float pivot, int startIndex, int endIndex);
		void  Quick_Sort(vector<float> &array, vector<string> &ind, int startIndex, int endIndex);

		float SplitArray(vector<float> &array, vector<cl_int2> &ind, float pivot, int startIndex, int endIndex);
      void  Quick_Sort(vector<float> &array, vector<cl_int2> &ind, int startIndex, int endIndex);

		float SplitArray(vector<float> &array, vector<int> &ind, float pivot, int startIndex, int endIndex);
      void  Quick_Sort(vector<float> &array, vector<int> &ind, int startIndex, int endIndex);

		int array_bound(float *array, int size, float val);
        
        float Roche_lobe(float q, float a, float *RL_over_a);



		bool string_comp(string s1, string s2);

		template <class T> T string_to_number(string str, bool *err){
			T value;
		   *err = false;

		   stringstream stream(str);
		   stream >> value;

		   if(stream.fail())
		      *err = true;

		   return value;
		}

		template <class T> string to_string(T const &obj){
			ostringstream out;
			out << obj;
			return out.str();
		}

};


#endif
